<template>
    <div class="flex items-center justify-between mb-4">
        <Breadcrumb nameRouteHome="admin" textRouteHome="Tổng quan">
            <ItemBreadcrumb>Quản lý người dùng</ItemBreadcrumb>
        </Breadcrumb>
        <LinkButton nameRoute="admin-user-create">
            <PlusCircleIcon class="text-white" />
            <span>Thêm mới</span>
        </LinkButton>
    </div>

    <div class="card">
        <div class="card-header border-b-none">
            <form
                @submit.prevent="submitSearchForm"
                class="flex items-end gap-3"
            >
                <div class="form-control">
                    <div>Từ khóa:</div>
                    <label for="keyword">
                        <input
                            v-model="keyword"
                            id="keyword"
                            type="text"
                            class="focus:border-main-color rounded-md border border-gray-200 text-sm mt-1 px-3 py-2"
                            placeholder="Họ tên hoặc email..."
                            autocomplete="off"
                        />
                    </label>
                </div>
                <div class="form-control">
                    <label for="role">
                        <div>Chức vụ:</div>
                        <select
                            v-model="role"
                            id="role"
                            class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2"
                        >
                            <option value="">Tất cả</option>
                            <option
                                :key="role.id"
                                v-for="role in SELECT_OPTION_ROLE"
                                :value="role.id"
                            >
                                {{ role.text }}
                            </option>
                        </select>
                    </label>
                </div>
                <BasicButton
                    type="submit"
                    classCustom="bg-color-warning hover:shadow-hover-warning"
                >
                    <SearchIcon class="text-white" />
                    <span>Tìm kiếm</span>
                </BasicButton>
            </form>
        </div>
        <table>
            <thead>
                <tr>
                    <th>STT</th>
                    <th>Họ tên</th>
                    <th>Email</th>
                    <th class="text-center">Chức vụ</th>
                    <th>Thời gian tạo</th>
                    <th class="text-center">Hành động</th>
                </tr>
            </thead>
            <tbody>
                <template v-if="!isLoading">
                    <template v-if="usersComputed && usersComputed.length">
                        <tr
                            :key="user.id"
                            v-for="(user, index) in usersComputed"
                        >
                            <td>{{ index + 1 }}</td>
                            <td>{{ user.name }}</td>
                            <td>{{ user.email }}</td>
                            <td class="text-center">
                                <span
                                    v-if="user.role === ROLE_ADMIN"
                                    class="bg-color-danger text-white text-xs font-semibold rounded-2xl px-3 py-1"
                                >
                                    Admin
                                </span>
                                <span
                                    v-else-if="user.role === ROLE_TEACHER"
                                    class="bg-color-primary text-white text-xs font-semibold rounded-2xl px-3 py-1"
                                >
                                    Giáo viên
                                </span>
                                <span
                                    v-else
                                    class="bg-color-success text-white text-xs font-semibold rounded-2xl px-3 py-1"
                                >
                                    Học sinh
                                </span>
                            </td>
                            <td>{{ user.created_at }}</td>
                            <td>
                                <div
                                    class="box-actions flex items-center justify-center gap-1"
                                >
                                    <router-link
                                        :to="{
                                            name: 'admin-user-view',
                                            params: { userId: user.id }
                                        }"
                                        v-tooltip="'Xem'"
                                        class="action-view"
                                    >
                                        <EyeIcon />
                                    </router-link>
                                    <router-link
                                        :to="{
                                            name: 'admin-user-update',
                                            params: { userId: user.id }
                                        }"
                                        v-tooltip="'Sửa'"
                                        class="action-edit"
                                    >
                                        <PencilIcon />
                                    </router-link>
                                    <div
                                        @click="onDelete(user.id)"
                                        v-tooltip="'Xóa'"
                                        class="cursor-pointer action-delete"
                                    >
                                        <TrashIcon />
                                    </div>
                                </div>
                            </td>
                        </tr>
                    </template>
                    <template v-else>
                        <tr class="no-data-table">
                            <td colspan="6" class="text-center">
                                Không có dữ liệu
                            </td>
                        </tr>
                    </template>
                </template>
                <template v-else>
                    <tr>
                        <td colspan="6" class="text-center">
                            <SpinLoading />
                        </td>
                    </tr>
                </template>
            </tbody>
        </table>
        <div
            v-if="!isLoading && usersComputed && usersComputed.length"
            class="flex justify-end p-6"
        >
            <BasicPagination
                @onClickPage="onClickPage"
                :currentPage="currentPage"
                :lastPage="lastPage"
            />
        </div>
    </div>
</template>

<script>
import { computed, ref, watch } from "vue";
import { useRoute, useRouter } from "vue-router";
import { ROLE_ADMIN, ROLE_TEACHER, SELECT_OPTION_ROLE } from "@/constants";
import timeHelper from "@/helper/timeHelper";
import Swal from "sweetalert2";
import { createToast } from "mosha-vue-toastify";

import useFetchAllUser from "@/hooks/user/useFetchAllUser";
import useDeleteUser from "@/hooks/user/useDeleteUser";

import {
    PlusCircleIcon,
    SearchIcon,
    EyeIcon,
    PencilIcon,
    TrashIcon
} from "@heroicons/vue/outline";
import SpinLoading from "@/components/loading/SpinLoading.vue";
import Breadcrumb from "@/components/breadcrumb/Breadcrumb.vue";
import ItemBreadcrumb from "@/components/breadcrumb/ItemBreadcrumb.vue";
import BasicButton from "@/components/button/BasicButton.vue";
import LinkButton from "@/components/button/LinkButton.vue";
import BasicPagination from "@/components/pagination/BasicPagination.vue";

export default {
    components: {
        PlusCircleIcon,
        SearchIcon,
        EyeIcon,
        PencilIcon,
        TrashIcon,
        SpinLoading,
        Breadcrumb,
        ItemBreadcrumb,
        BasicButton,
        LinkButton,
        BasicPagination
    },
    setup() {
        const route = useRoute();
        const router = useRouter();
        const users = ref([]);
        const { isLoading, listUser, onFetchAllUser } = useFetchAllUser();
        const { errorResponse, onDeleteUser } = useDeleteUser();

        async function onFetch() {
            await onFetchAllUser(route.query);
            users.value = listUser.value.data;
        }
        onFetch();

        const usersComputed = computed(() => {
            if (users.value && users.value.length) {
                return users.value.map(user => {
                    return {
                        ...user,
                        created_at: timeHelper.getTimeString(
                            "H:i:s - d/m/Y",
                            timeHelper.getTimeInt(user.created_at)
                        )
                    };
                });
            } else {
                return [];
            }
        });

        // search
        const keyword = ref(route.query.keyword || null);
        const role = ref(route.query.role || "");
        async function submitSearchForm() {
            await onFetchAllUser({ keyword: keyword.value, role: role.value });
            users.value = listUser.value.data;

            const path = route.path;

            let query = {};
            if (keyword.value) query = { ...query, keyword: keyword.value };
            if (role.value !== null && role.value !== "")
                query = { ...query, role: role.value };

            router.push({ path, query });
        }

        // update currentPge and lastPage when change listUser
        const currentPage = ref(1);
        const lastPage = ref(1);
        watch(listUser, newValue => {
            currentPage.value = newValue.current_page;
            lastPage.value = newValue.last_page;
        });

        // click pagination
        async function onClickPage(value) {
            router.push({
                path: route.path,
                query: { ...route.query, page: value }
            });

            await onFetchAllUser({ ...route.query, page: value });
            users.value = listUser.value.data;
        }

        // deleteUser
        async function onDelete(id) {
            Swal.fire({
                icon: "question",
                title: `<span style="font-size: 23px;">Bạn có chắc muốn xóa người dùng này không?</span>`,
                confirmButtonText: "Xóa",
                showDenyButton: true,
                denyButtonText: "Hủy",
                focusConfirm: false
            }).then(async result => {
                if (result.isConfirmed) {
                    // show loading
                    document.getElementById("full-page-loading").style.display =
                        "block";

                    await onDeleteUser(id);

                    // hide loading
                    document.getElementById("full-page-loading").style.display =
                        "none";

                    // check error from server
                    if (errorResponse.value) {
                        createToast("Xóa thất bại, đã có lỗi xảy ra", {
                            showIcon: true,
                            type: "danger"
                        });
                    } else {
                        users.value = users.value.filter(user => {
                            return user.id != id;
                        });
                        createToast("Xóa thành công", {
                            showIcon: true,
                            type: "success"
                        });
                    }
                }
            });
        }

        return {
            ROLE_ADMIN,
            ROLE_TEACHER,
            SELECT_OPTION_ROLE,
            isLoading,
            usersComputed,
            keyword,
            role,
            submitSearchForm,
            currentPage,
            lastPage,
            onClickPage,
            onDelete
        };
    }
};
</script>
